package com.dst.slms.base.web.controller;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.ResponseBody;
import org.springframework.web.servlet.ModelAndView;
import com.dst.slms.common.entity.sic.SelectorItemCollection;
import com.dst.slms.common.service.util.DataGrid;
import com.dst.slms.common.service.util.EntityQuery;
import com.dst.slms.common.support.ICrudService;
import com.dst.slms.common.support.controller.CoreBaseController;
import com.dst.slms.common.utils.FieldMetaAnnotationHelper;
import com.dst.slms.common.utils.R;
import org.apache.shiro.authz.annotation.RequiresPermissions;
import com.dst.slms.common.annotation.SysPermissionName;
import com.dst.slms.base.entity.TaxRateInfo;
import com.dst.slms.base.service.ITaxRateService;

/**   
 * 税率 控制类此类会在发布元数据时覆盖
 * @Title: Controller
 * @Description: 税率
 * @author 
 * @date 2020-05-02 16:18:29
 * @version V1.0   
 *
 */
public abstract class AbstractTaxRateController extends CoreBaseController {

	@Autowired
	private ITaxRateService iTaxRateService;
	
	@Override
	public String getListName() {
		return "com/dst/slms/base/taxrate/taxRateList";
	}
	
	@Override
	public String getEditName() {
		return "com/dst/slms/base/taxrate/taxRateEdit";
	}

	@Override
	public String getModleName() {
		return "model";
	}
	
	@Override
	public ICrudService getService() {
		return iTaxRateService;
	}
	
	public Object createNewModel(HttpServletRequest req) {
		TaxRateInfo info = new TaxRateInfo();
		info.setNumber(getService().getNumber(info.getClass().getName()));
		
		return info;
	}
	
	@Override
	public SelectorItemCollection getEditSelector() {
		SelectorItemCollection sic = new SelectorItemCollection();
		sic.add("name");
		sic.add("number");
		sic.add("remake");
		sic.add("isEnable");
		sic.add("taxRate");
		return sic;
	}
	
	@RequiresPermissions("tae:taxRate:list")		
	@ResponseBody
    @RequestMapping(params = "list")
	public void list(TaxRateInfo info, HttpServletRequest request, HttpServletResponse response, DataGrid dataGrid) {
		super.list(info, request, response, dataGrid);
	}

	@SysPermissionName(name="列表查看")
	@RequiresPermissions("tae:taxRate:list")	
	@ResponseBody
    @RequestMapping(value = "/listPage")
	public ModelAndView listPage(HttpServletRequest request) {
		return super.listPage(request);
	}
	
	@SysPermissionName(name="列表新增")
	@RequiresPermissions("tae:taxRate:addnew")	
	@ResponseBody
    @RequestMapping(value = "/addPage")
	public ModelAndView addPage(HttpServletRequest req) {
		return super.addPage(req);
	}
	
	@SysPermissionName(name="表单查看")
	@RequiresPermissions("tae:taxRate:view")	
	@ResponseBody
    @RequestMapping(value = "/viewPage")
	public ModelAndView viewPage(TaxRateInfo info, HttpServletRequest req) {
		return super.viewPage(info, req);
	}
	
	@SysPermissionName(name="列表修改")
	@RequiresPermissions("tae:taxRate:edit")
	@ResponseBody
    @RequestMapping(value = "/editPage")
	public ModelAndView editPage(TaxRateInfo info, HttpServletRequest req) {
		return super.editPage(info, req);
	}
	
	@SysPermissionName(name="保存")
	@RequiresPermissions("tae:taxRate:save")
	@ResponseBody
    @RequestMapping(value = "/save")
	public R saveAction(TaxRateInfo info, HttpServletRequest req) {
		return super.saveAction(info, req);
	}
	
	@SysPermissionName(name="提交")
	@RequiresPermissions("tae:taxRate:submit")
	@ResponseBody
    @RequestMapping(value = "/submit")
	public R submitAction(TaxRateInfo info, HttpServletRequest req) {
		return super.submitAction(info, req);
	}
	
	@SysPermissionName(name="删除")
	@RequiresPermissions("tae:taxRate:delete")	
	@ResponseBody
    @RequestMapping(value = "/delete")
	public R deleteAction(TaxRateInfo info, HttpServletRequest req) {
		return super.deleteAction(info, req);
	}
	
	/**
	 * 导出excel
	 */
	@SysPermissionName(name="导出excel")
	@RequiresPermissions("tae:taxRate:downExcel")
	@RequestMapping(value = "/downExcel")
	public void downExcel(TaxRateInfo info,HttpServletRequest request, HttpServletResponse response, DataGrid dataGrid) {
		EntityQuery cq = getQueryExecutor(request, info, dataGrid);
		listToExcel(cq, request, response,FieldMetaAnnotationHelper.getEntityName(info.getClass().getName()));
	}
}
